#include "asm86.h"
#include "ti86asm.inc"

.org _asm_exec_ram

var = $C0F9         ; Miscellaneous Variable
ivar = $C0FA		; Used when getting initials
xVar = $C0FB 		; Keeps track of x
yVar = $C0FC		; Keeps track of y
hv = $C0FD
p1 = $C0FE			; Player 1's Initial
p2 = $C0FF			; Player 2's Initial
player = $C100		; Whose turn is it?
p1s = $C101			; Player 1's Score
p2s = $C102			; Player 2's Score

	nop
	jp Start
	.dw 0
	.dw Title

Title:
	.db "Tempomalsxparilo v1",0

Start:
  call _runindicoff
  call _clrScrn
  jr GetInit
ContStart
  ld a,$00
  ld (p1s),a
  call p1Score
  ld a,$FF
  ld (p2s),a
  call ldp2s
  call NextPlayer
  ld b,$45
  ld c,$3B
  call ChgPixel
  inc c
  call ChgPixel
  inc b
  call ChgPixel
  dec b
  inc c
  call ChgPixel
  call DrawGrid
  ld b,$00
  ld c,$01
  call VCDLine
  call Select
  call _clrScrn
  ret



GetInit:
  call PutLogo
  ld a,12
  ld (_penCol),a
  ld a,10
  ld (_penRow),a
  ld hl,pOne
  call _vputs
  ld a,7
  ld (_penCol),a
  ld a,16
  ld (_penRow),a
  ld hl,InitTxt
  call _vputs
  ld a,$00
  ld (ivar),a
  ld (p1),a
  ld bc,0
  ld (_penCol),bc
  ld bc,30
  ld (_penRow),bc
  ld hl,am
  call _vputs
  ld bc,0
  ld (_penCol),bc
  ld bc,42
  ld (_penRow),bc
  ld hl,nz
  call _vputs
  ld b,0
  ld c,38
  call ChgPixel
  inc b
  call ChgPixel
  dec c
  call ChgPixel
  inc b
  inc c
  call ChgPixel
  ld b,00
  ld c,38
GetInitWait:
  or $11
  push bc
   call _getkey
  pop bc
  cp $07
  jp z,Finish
  cp $06
  jr z,PickInit
  cp $1A
  jp z,GetInitCase
  cp $04
  jp z,UpLevel
  cp $02
  jp z,PrevInit
  cp $01
  jp z,NextInit
  cp $03
  jp z,UpLevel
  jr GetInitWait
PickInit:
  push bc
   ld a,b
   ld b,5
   ld c,0
Divit:
   inc c
   sub b
   jr nc,Divit
   ld a,c
   ld (var),a
   call CapInit
   ld (var),a
  pop bc
  ld a,c
  cp 50
  ld a,(var)
  call z,mzRow
  ld (var),a
  ld a,(p1)
  cp $00
  jr nz,p2Init
  ld a,$08
  ld (_penCol),a
  ld a,$39
  ld (_penRow),a
  ld a,(var)
  ld (p1),a
  call _vputmap
  ld a,11
  ld (_penCol),a
  ld a,10
  ld (_penRow),a
  ld hl,pTwo
  call _vputs
  jr GetInitWait
CapInit:
  ld a,(ivar)
  cp $01
  ld a,(var)
  jr nz,CapInitNo
  add a,$40
  ret
CapInitNo:
  add a,$60
  ret
mzRow:
  add a,$0D
  ret
p2Init:
  ld a,(var)
  ld (p2),a
  jp ClrInit
GetInitCase
  ld a,(ivar)
  cp $00  
  jr z,GetInitUpper
  ld a,$00
  ld (ivar),a
  push bc
   ld bc,0
   ld (_penCol),bc
   ld bc,30
   ld (_penRow),bc
   ld hl,am
   call _vputs
   ld bc,0
   ld (_penCol),bc
   ld bc,42
   ld (_penRow),bc
   ld hl,nz
   call _vputs
  pop bc
  jp GetInitWait
GetInitUpper:
  ld a,$01
  ld (ivar),a
  push bc
   ld bc,0
   ld (_penCol),bc
   ld bc,30
   ld (_penRow),bc
   ld hl,amCaps
   call _vputs
   ld bc,0
   ld (_penCol),bc
   ld bc,42
   ld (_penRow),bc
   ld hl,nzCaps
   call _vputs
  pop bc
  jp GetInitWait
PrevInit:
  call Pointer
  ld a,b
  sub $05
  cp $FB
  call z,BackRight
  ld b,a
  call Pointer
  jp GetInitWait
NextInit:  
  call Pointer
  ld a,b
  add a,$05
  cp $41
  call z,BackLeft
  ld b,a
  call Pointer
  jp GetInitWait
UpLevel:
  call Pointer
  ld a,c
  cp 38
  ld c,38
  call z,DownLevel
  call Pointer
  jp GetInitWait  
Pointer:
  push bc
   call ChgPixel
   inc b
   call ChgPixel
   dec c
   call ChgPixel
   inc b
   inc c
   call ChgPixel
  pop bc
  ret
BackRight:
  ld b,60
  ld a,c
  cp 38
  ld a,b
  jr z,DownLevel
  ld c,38
  ret
BackLeft:
  ld b,0
  ld a,c
  cp 38
  ld a,b
  jr z,DownLevel
  ld c,38
  ret
DownLevel:
  ld c,50
  ret
ClrInit:
  call _clrLCD
  ld a,$0A
  ld (_penCol),a
  ld a,$39
  ld (_penRow),a
  ld a,(p1)
  call _vputmap
  ld a,$4A
  ld (_penCol),a
  ld a,$39
  ld (_penRow),a
  ld a,(p2)
  call _vputmap
  jp ContStart
Finish:
  call _clrScrn
  ret



DrawGrid:
  call PutLogo
  ld b,$00
  ld c,$00
  ld a,$78
  ld (xVar),a
  ld a,$38
  ld (yVar),a
dot:
  call SetPixel
  ld a,b
  ld hl,xVar
  cp (hl)
  jr z,incX
  add a,$08
  ld b,a
  jr dot
incX:
  ld a,c
  ld hl,yVar
  cp (hl)
  ret z
  add a,$08
  ld c,a
  ld a,$00
  ld b,a
  jr dot



Select:
  push bc
   call _getkey
  pop bc
  cp $07
  ret z
  cp $06
  jp z,LineHere
  cp $1A
  jp z,Rotate
  cp $04
  jr z,NextY
  cp $02
  jr z,PrevX
  cp $01
  jr z,NextX
  cp $03
  jp z,PrevY
  jr Select
NextY:
  ld a,c
  cp $31
  jr z,Select
  cp $38
  jr z,Select
  ld a,(hv)
  cp $01
  jr nz,NextVY
  call HCDLine
  ld a,c
  add a,$08
  ld c,a
  call HCDLine
  jr Select
NextVY:
  call VCDLine
  ld a,c
  add a,$08
  ld c,a
  call VCDLine
  jr Select
PrevX:
  ld a,b
  cp $00
  jr z,Select
  cp $01
  jr z,Select
  ld a,(hv)
  cp $01
  jr nz,PrevVX
  call HCDLine
  ld a,b
  sub $08
  ld b,a
  call HCDLine
  jp Select
PrevVX:
  call VCDLine
  ld a,b
  sub $08
  ld b,a
  call VCDLine
  jp Select
NextX:
  ld a,b
  cp $78
  jp z,Select
  cp $71
  jp z,Select
  ld a,(hv)
  cp $01
  jr nz,NextVX
  call HCDLine
  ld a,b
  add a,$08
  ld b,a
  call HCDLine
  jp Select
NextVX:
  call VCDLine
  ld a,b
  add a,$08
  ld b,a
  call VCDLine
  jp Select
PrevY:
  ld a,c
  cp $01
  jp z,Select
  cp $00
  jp z,Select
  ld a,(hv)
  cp $01
  jr nz,PrevVY
  call HCDLine
  ld a,c
  sub $08
  ld c,a
  call HCDLine
  jp Select
PrevVY:
  call VCDLine
  ld a,c
  sub $08
  ld c,a
  call VCDLine
  jp Select
LineHere:
  ld a,$00
  ld (var),a
  call GetPixel
  cp $00
  jp nz,Select
  call NextPlayer
  ld a,(player)
  ld hl,p1
  cp (hl)
  ld a,(p1)
  ld (player),a
  call z,p2Playing
  ld a,(hv)
  cp $01
  jp nz,LineVHere
  call HCSLine
CheckBotBox:
  push bc
   dec b
   inc c
   call GetPixel
  pop bc
  cp $00
  jr z,CheckTopBox
  push bc
   ld a,b
   add a,$07
   ld b,a
   inc c
   call GetPixel
  pop bc
  cp $00
  jr z,CheckTopBox
  push bc
   ld a,c
   add a,$08
   ld c,a
   call GetPixel
  pop bc
  cp $00
  jr z,CheckTopBox
  push bc
   inc b
   ld a,b
   ld (_penCol),a
   inc c
   ld a,c
   ld (_penRow),a
   ld b,1
   ld hl,player
   call _vputsn
  pop bc
  ld a,(player)
  ld hl,p2
  cp (hl)
  ld a,(p1s)
  call z,ldp2s
  inc a
  ld (p1s),a
  call p1Score
  ld a,$01
  ld (var),a
  call CheckScore
  cp $00
  ret z
CheckTopBox:
  push bc
   dec b
   dec c
   call GetPixel
  pop bc
  cp $00
  jp z,CheckPlay
  push bc
   ld a,b
   add a,$07
   ld b,a
   dec c
   call GetPixel
  pop bc
  cp $00
  jp z,CheckPlay
  push bc
   ld a,c
   sub $08
   ld c,a
   call GetPixel
  pop bc
  cp $00
  jp z,CheckPlay
  push bc
   inc b
   ld a,b
   ld (_penCol),a
   ld a,c
   sub $07
   ld (_penRow),a
   ld b,1
   ld hl,player
   call _vputsn
  pop bc
  ld a,(player)
  ld hl,p2
  cp (hl)
  ld a,(p1s)
  call z,ldp2s
  inc a
  ld (p1s),a
  call p1Score
  ld a,$01
  ld (var),a
  call CheckScore
  cp $00
  ret z
CheckPlay:
  call AnotherTurn
  jp Select
ldp2s:
  ld a,(p2s)
  inc a
  ld (p2s),a
  push bc
   ld a,$50
   ld (_penCol), a
   ld a,$39
   ld (_penRow), a
   ld hl,p2s
   ld l,(hl)
   ld h,$00
   call _divHLby10
   add a,$30
   ld c,a
   call _divHLby10
   add a,$30
   ld b,a
   call _divHLby10
   add a,$30
   cp $30
   jr z,PutDigit2
   call _vputmap
PutDigit2
   cp $30
   call z,CheckDigit2
   jr z,PutDigit3
   ld a,b
   call _vputmap
PutDigit3:
   ld a,c
   call _vputmap
  pop bc
  ld a,(p1s)
  dec a
  ret
CheckDigit2:
  ld a,b
  cp $30
  ret
p2Playing:
  ld a,(p2)
  ld (player),a
  ret
LineVHere:
  call VCSLine
CheckLeftBox:
  push bc
   dec b
   dec c
   call GetPixel
  pop bc
  cp $00
  jr z,CheckRightBox
  push bc
   ld a,b
   sub $08
   ld b,a
   call GetPixel
  pop bc
  cp $00
  jr z,CheckRightBox
  push bc
   dec b
   ld a,c
   add a,$07
   ld c,a
   call GetPixel
  pop bc
  cp $00
  jr z,CheckRightBox
  push bc
   ld a,b
   sub $06
   ld (_penCol),a
   ld a,c
   ld (_penRow),a
   ld b,1
   ld hl,player
   call _vputsn
  pop bc
  ld a,(player)
  ld hl,p2
  cp (hl)
  ld a,(p1s)
  call z,ldp2s
  inc a
  ld (p1s),a
  call p1Score
  ld a,$01
  ld (var),a
  call CheckScore
  cp $00
  ret z
CheckRightBox:
  push bc
   inc b
   dec c
   call GetPixel
  pop bc
  cp $00
  jp z,CheckPlay
  push bc
   ld a,b
   add a,$08
   ld b,a
   call GetPixel
  pop bc
  cp $00
  jp z,CheckPlay
  push bc
   inc b
   ld a,c
   add a,$07
   ld c,a
   call GetPixel
  pop bc
  cp $00
  jp z,CheckPlayV
  push bc
   inc b
   inc b
   ld a,b
   ld (_penCol),a
   ld a,c
   ld (_penRow),a
   ld b,1
   ld hl,player
   call _vputsn
  pop bc
  ld a,(player)
  ld hl,p2
  cp (hl)
  ld a,(p1s)
  call z,ldp2s
  inc a
  ld (p1s),a
  call p1Score
  ld a,$01
  ld (var),a
  call CheckScore
  cp $00
  ret z
CheckPlayV:
  call AnotherTurn
  jp Select
AnotherTurn:
  ld a,(var)
  cp $01
  ret nz
  call NextPlayer
  ld (var),a
  ld a,(player)
  ld hl,p1
  cp (hl)
  ld a,(p1)
  ld (player),a
  call z,p2Playing
  ret
Rotate:
  ld a,(hv)
  cp $01
  jr z,RotToV
  ld a,$01
  ld (hv),a
  call VCDLine
  dec c
  inc b
  ld a,b
  cp $79
  jr z,RotTooFarX
  call HCDLine
  jp Select
RotTooFarX:
  sub $08
  ld b,a
  call HCDLine
  jp Select
RotToV:
  ld a,$00
  ld (hv),a
  call HCDLine
  inc c
  dec b
  ld a,c
  cp $39
  jr z,RotTooFarY
  call VCDLine
  jp Select
RotTooFarY:
  sub $08
  ld c,a
  call VCDLine
  jp Select
NextPlayer:
  push bc
   ld b,$05
   ld c,$3B
   call ChgPixel
   inc c
   call ChgPixel
   inc b
   call ChgPixel
   dec b
   inc c
   call ChgPixel
   ld b,$45
   ld c,$3B
   call ChgPixel
   inc c
   call ChgPixel
   inc b
   call ChgPixel
   dec b
   inc c
   call ChgPixel
  pop bc
  ret
p1Score:
  push bc
   ld a,$10
   ld (_penCol), a
   ld a,$39
   ld (_penRow), a
   ld hl,p1s
   ld l,(hl)
   ld h,$00
   call _divHLby10
   add a,$30
   ld c,a
   call _divHLby10
   add a,$30
   ld b,a
   call _divHLby10
   add a,$30
   cp $30
   jr z,PutDigit2p1
   call _vputmap
PutDigit2p1:
   cp $30
   call z,CheckDigit2
   jr z,PutDigit3p1
   ld a,b
   call _vputmap
PutDigit3p1:
   ld a,c
   call _vputmap
  pop bc
  ret
CheckScore:
  ld a,(p1s)
  ld hl,p2s
  add a,(hl)
  cp $69
  ret c
  ld a,(p1s)
  cp (hl)
  jp c,p2Wins
  jp p1Wins
  ret



PutLogo:
  ld hl,TitleLogo
  ld de,$FC0F
  ld b,$40
GFXNewRow:
  push bc
   ldi
   ld bc,$0F
   ex de,hl
   add hl,bc
   ex de,hl
  pop bc
  djnz GFXNewRow
  ret



VCSLine:     ;  y-coord in c, x-coord in b
  push bc
  call ChgPixel
  inc c
  call ChgPixel
  inc c
  call ChgPixel
  inc c
  call ChgPixel
  inc c
  call ChgPixel
  inc c
  call ChgPixel
  inc c
  call ChgPixel
  pop bc
  ret

HCSLine:     ;  y-coord in c, x-coord in b
  push bc
  call ChgPixel
  inc b
  call ChgPixel
  inc b
  call ChgPixel
  inc b
  call ChgPixel
  inc b
  call ChgPixel
  inc b
  call ChgPixel
  inc b
  call ChgPixel
  pop bc
  ret

VCDLine:     ;  y-coord in c, x-coord in b
  push bc
  inc c
  call ChgPixel
  inc c
  inc c
  call ChgPixel
  inc c
  inc c
  call ChgPixel
  pop bc
  ret

HCDLine:     ;  y-coord in c, x-coord in b
  push bc
  inc b
  call ChgPixel
  inc b
  inc b
  call ChgPixel
  inc b
  inc b
  call ChgPixel
  pop bc
  ret

VRSLine:     ;  y-coord in c, x-coord in b
  push bc
  call ResPixel
  inc c
  call ResPixel
  inc c
  call ResPixel
  inc c
  call ResPixel
  inc c
  call ResPixel
  inc c
  call ResPixel
  inc c
  call ResPixel
  pop bc
  ret


p1Wins:
  ld a,$02
  ld (_curCol),a
  ld a,$03
  ld (_curRow),a
  ld hl,p1Won
  call _puts
  call _pause
  ld a,$00
  ret

p2Wins:
  ld a,$02
  ld (_curCol),a
  ld a,$03
  ld (_curRow),a
  ld hl,p2Won
  call _puts
  call _pause
  ld a,$00
  ret



GetPixel:  ;  X-value in b, Y-value in c   
  call FindPixel
  and (hl)
  ret     ;a=nonzero:pixel is 1, a=zero:pixel is 0

ChgPixel:  ;  X-value in b, Y-value in c   
  call FindPixel
  xor (hl)
  ld (hl), a
  ret

SetPixel:  ;  X-value in b, Y-value in c   
  call FindPixel
  or (hl)
  ld (hl), a
  ret

ResPixel:  ; X-value in b, Y-value in c   
  call FindPixel
  cpl
  and (hl)
  ld (hl), a
  ret

;--------------------------------------------------------------------
; The Eble-Yopp-Yopp-Eble-Eble-Eble-Yopp Fast FindPixel Routine :)
; 36 bytes / 121 t-states not counting ret or possible push/pop of BC
;--------------------------------------------------------------------
; Input:  D = y
;         E = x
; Output: HL= address of byte in video memory
;         A = bitmask (bit corresponding to pixel is set)
;         C is modified
;
; +-----------+
; |(0,0)      |  <- Screen layout
; |           |
; |   (127,63)|
; +-----------+
;
;--------------------------------------------------------------------
FindPixel:
        push bc
	ld e,b
	ld d,c
	ld hl,FP_Bits
        ld a,e
        and $07         ; a = bit offset
        add a,l
        ld l,a
        adc a,h
        sub l
        ld h,a
        ld c,(hl)       ; c = bitmask for (hl)
;48 t-states up to this point
        ld hl,FP_RLD
        ld (hl),d
        ld a,e          ; a = x/8 (byte offset within row)
        rrca
        rrca
        rrca
        rld
        or $FC
        ld l,(hl)
        ld h,a          ; hl -> byte in vid mem
        ld a,c          ; now a = bitmask for (hl)
;121 t-states up to this point
        pop bc
	ret

FP_RLD:  .db $00
FP_Bits: .db $80,$40,$20,$10,$08,$04,$02,$01
pOne: .db "Player One",0
pTwo: .db "Player Two",0
InitTxt: .db "Choose  Initial",0
am: .db "a b c d e f  g h  i  j k l m",0
nz: .db "n o p q r  s  t u vwx y z",0
amCaps: .db "A B C D E FG H  I  J KLM",0
nzCaps: .db "NO PQ R S T U VWX Y Z",0
p1Won: .db " Player One Wins! ",0
p2Won: .db " Player Two Wins! ",0
ErrorMsg: .db "Error!",0
TitleLogo:
  .db %00000111
  .db %00000010
  .db %00000010
  .db %00000010
  .db %00010010
  .db %00101000
  .db %00110000
  .db %00011000

  .db %00000000
  .db %00011010
  .db %00010101
  .db %00010001
  .db %00000000
  .db %00110000
  .db %00101000
  .db %00110010

  .db %00100101
  .db %00000101
  .db %00000010
  .db $00000000
  .db %00110100
  .db %00101010
  .db %00101010
  .db %00100010

  .db %00000000
  .db %00011000
  .db %00101000
  .db %00101011
  .db %00011001
  .db %00000001
  .db %00000001
  .db %00010001

  .db %00101000
  .db %00000000
  .db %00110000
  .db %00100110
  .db %00010101
  .db %00110110
  .db %00000100
  .db %00000000

  .db %00011000
  .db %00101000
  .db %00101000
  .db %00011000
  .db %00000000
  .db %00000101
  .db %00000110
  .db %00010100

  .db %00000100
  .db %00010000
  .db %00010011
  .db %00010001
  .db %00000001
  .db %00000001
  .db %00010001
  .db %00101000

  .db %00101000
  .db %00010000
  .db %00000000
  .db %00000000
  .db %00000010
  .db %00000010
  .db %00101010
  .db %00010010

.end
